var fs = require('fs');
var reactClass = require('./react-class');
var reserved = require('./reserved-words').reserved;

var createFile = function (path) {

    if (!path) {
        throw new Error('Invalid input information. Inform the --class argument');
    }

    var paths = path.split('/');

    var filePosition = paths.length - 1;

    if (paths.length > 1) {
        createDirectory(paths.slice(0, filePosition))
    }

    var fileName = paths[filePosition].trim();

    if (!fileName) {
        throw new Error('Missing class name');
    }


    if (reserved.indexOf(fileName) != -1) {
        throw new Error('Reserved name');
    }

    var regex = '[^a-zA-Z0-9]+';

    if (fileName.match(regex)) {
        throw new Error('You can not use special characters');
    }

    var body = reactClass.createReactClassStructure(fileName);

    fs.writeFile(`./${path}.js`, body, function (err) {
        if (err) {
            return console.log(err);
        }

        console.log('The class was created!');

    });

    return 'Creating class file';

}

var createDirectory = function (arrayOfPaths) {

    for (var i in arrayOfPaths) {

        if (!fs.existsSync(arrayOfPaths[i])) {

            fs.mkdirSync(arrayOfPaths[i]);

        }

    }
}

exports.createFile = createFile;